require 'fundraising_project/fundrequest'

module CrowdFund
  describe FundRequest do

    before do
      @request = FundRequest.new("BBN")
      @initial_funding = 1000
      @target_funding = 10000
      @project = Project.new("RuppArena", @initial_funding, @target_funding)
      @request.add_project(@project)
    end

    it "loses funding when a number not divisible by 2 or 3 is rolled" do
      allow_any_instance_of(Die).to receive(:roll).and_return(5)
      delta = 25
      @request.alter_funding(delta, 2)
      expect(@project.current_funding_amount).to eq(@initial_funding - (delta * 2))
    end

    it "gains funding when an even number is rolled" do
      allow_any_instance_of(Die).to receive(:roll).and_return(4)
      delta = 25
      @request.alter_funding(delta, 1)
      expect(@project.current_funding_amount).to eq((@initial_funding + (delta)).to_i)
    end  

    it "gains funding when a number divisible by 3 is rolled" do
      allow_any_instance_of(Die).to receive(:roll).and_return(3)
      delta = 25
      @request.alter_funding(delta, 1)
      expect(@project.current_funding_amount).to eq((@initial_funding + (delta)).to_i)
    end    
  end
end